unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, MConnect, SConnect, ScktComp, XPMan, ExtCtrls, ComCtrls,
  ImgList, VistaAltFixUnit;

type
  TForm1 = class(TForm)
    ClientSocket1: TClientSocket;
    XPManifest1: TXPManifest;
    Timer3: TTimer;
    VistaAltFix1: TVistaAltFix;
    Button1: TButton;
    Button2: TButton;
    Label15: TLabel;
    ImageON: TImage;
    ImageOFF: TImage;
    Timer1: TTimer;
    ComboBox1: TComboBox;
    Label1: TLabel;
    Button3: TButton;
    Button5: TButton;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure ClientSocket1Disconnect(Sender: TObject;
      Socket: TCustomWinSocket);
    procedure Button5Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure ClientSocket1Read(Sender: TObject; Socket: TCustomWinSocket);
    procedure ClientSocket1Connect(Sender: TObject;
      Socket: TCustomWinSocket);
    procedure Timer3Timer(Sender: TObject);
    procedure ClientSocket1Error(Sender: TObject; Socket: TCustomWinSocket;
      ErrorEvent: TErrorEvent; var ErrorCode: Integer);
    procedure ComboBox1Change(Sender: TObject);
    procedure ComboBox1DropDown(Sender: TObject);

  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  temp, inter, inter1, inter2, op1, op2, SSID, buff, str: string;

implementation

{$R *.dfm}

function cmd(console: String): string;
const BUFSIZE = 2000;
var SecAttr    : TSecurityAttributes; 
   hReadPipe, 
   hWritePipe : THandle;
   StartupInfo: TStartUpInfo;
   ProcessInfo: TProcessInformation; 
   Buffer     : Pchar; 
   WaitReason, 
   BytesRead  : DWord; 
begin 
with SecAttr do 
begin 
  nlength              := SizeOf(TSecurityAttributes); 
  binherithandle       := true; 
  lpsecuritydescriptor := nil; 
end; 
if Createpipe (hReadPipe, hWritePipe, @SecAttr, 0) then 
begin 
  Buffer  := AllocMem(BUFSIZE + 1); 
  FillChar(StartupInfo, Sizeof(StartupInfo), #0); 
  StartupInfo.cb          := SizeOf(StartupInfo); 
  StartupInfo.hStdOutput  := hWritePipe; 
  StartupInfo.hStdInput   := hReadPipe; 
  StartupInfo.dwFlags     := STARTF_USESTDHANDLES + 
                             STARTF_USESHOWWINDOW; 
  StartupInfo.wShowWindow := SW_HIDE; 
  if CreateProcess(nil, 
     PChar(console),
     @SecAttr, 
     @SecAttr, 
     true, 
     NORMAL_PRIORITY_CLASS, 
     nil, 
     nil, 
     StartupInfo,
     ProcessInfo) then
    begin 
      repeat 
        WaitReason := WaitForSingleObject(ProcessInfo.hProcess,100);
        Application.ProcessMessages; 
      until (WaitReason <> WAIT_TIMEOUT); 
      Repeat 
        BytesRead := 0; 
        ReadFile(hReadPipe, Buffer[0], BUFSIZE, BytesRead, nil); 
        Buffer[BytesRead]:= #0;
        OemToAnsi(Buffer,Buffer);
        Result := String(Buffer);
      until (BytesRead < BUFSIZE);
    end; 
  FreeMem(Buffer);
  CloseHandle(ProcessInfo.hProcess); 
  CloseHandle(ProcessInfo.hThread);
  CloseHandle(hReadPipe); 
  CloseHandle(hWritePipe); 
end; 
end;


procedure TForm1.Button1Click(Sender: TObject);
begin
  ClientSocket1.Socket.SendText('$CMD1' + #13#10);
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  ClientSocket1.Socket.SendText('$CMD2' + #13#10);
end;

procedure TForm1.Button3Click(Sender: TObject);
var
  i: integer;
begin
  ComboBox1.Enabled := false;
  SSID := '';
  Label1.Caption := ' ...';
  buff := cmd('netsh wlan show networks interface="' + inter + '"');
  if pos('    ',buff) > 0 then
  begin
    Label1.Caption := ' ';
    ComboBox1.Enabled := true;
    ClientSocket1.Active := false;
    ShowMessage('    ');
    exit;
  end;
  if pos('     ',buff) > 0 then
  begin
    Label1.Caption := ' ';
    ComboBox1.Enabled := true;
    ClientSocket1.Active := false;
    ShowMessage('     ');
    ComboBox1DropDown(nil);
    exit;
  end;
  if pos('ESP',buff) > 0 then
    begin
      SSID := copy(buff,pos('ESP',buff),10);
      Label1.Caption := SSID;
    end;
  if pos('ESP',buff) > 0 then
    begin
      buff := cmd('netsh wlan connect name=' + SSID + ' interface="' + inter + '"');
      if pos('    ',buff) > 0 then
      begin
        Label1.Caption := ' ';
        ComboBox1.Enabled := true;
        ClientSocket1.Active := false;
        ShowMessage('    ' + #13#10#13#10 +
        '       ->   ' + #13#10 +
        ' ->     ->  : ' + SSID + #13#10 +
        ' :    ->  ->  -> ');
        exit;
      end;

      for i:=1 to 200 do            //     2 .
      begin
        sleep(10);
        Application.ProcessMessages;
      end;

    end;
//-------------------------------------------
    buff := cmd('netsh wlan show interface');
    if pos(':',buff) > 0 then
    begin
      buff := copy(buff,pos(':',buff)+7,Length(buff)-pos(':',buff)+7);
      delete(buff, pos('%',buff), Length(buff));
      Label15.Caption := ' : ' + Trim(buff) + '%';
    end;                      
//-------------------------------------------
  buff := cmd('ping.exe -n 1 192.168.4.1');
  if pos('TTL',buff) > 0 then
  begin
    ClientSocket1.Port := 23;
    ClientSocket1.Host := '192.168.4.1';
    ClientSocket1.Open;
  end
  else
  begin
    Label1.Caption := ' ';
    ComboBox1.Enabled := true;
    ClientSocket1.Active := false;
    if SSID = '' then ShowMessage('ESP   ')
    else ShowMessage('   WiFi ');
  end;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  ComboBox1DropDown(nil);
end;

procedure TForm1.ClientSocket1Disconnect(Sender: TObject;
  Socket: TCustomWinSocket);
begin
  Label1.Caption := ' ';
  ComboBox1.Enabled := true;
  Button3.Enabled := true;
  Button5.Enabled := false;
  Timer3.Enabled := false;
  Label15.Caption := ' : 00 %';
  ImageON.Visible := False;
  ImageOFF.Visible := True;
end;

procedure TForm1.Button5Click(Sender: TObject);
begin
  ClientSocket1.Active := false;
  cmd('netsh wlan disconnect interface="' + inter + '"');
  ComboBox1.Enabled := true;
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  ClientSocket1.Active := false;
end;

procedure TForm1.ClientSocket1Read(Sender: TObject;
  Socket: TCustomWinSocket);
begin
  str := str + Socket.ReceiveText;
  if pos(#13#10,str) = 0 then exit; // 

try
  if pos('CMD1',str) > 0 then      // 
  begin
    ImageON.Visible := True;
    ImageOFF.Visible := False;
  end;
  if pos('CMD2',str) > 0 then      // 
  begin
    ImageON.Visible := False;
    ImageOFF.Visible := True;
  end;
  if pos('CMD3:',str) > 0 then      // 
  begin
    str := copy(str,pos(':',str)+1,Length(str)-pos(':',str)+1);
    str := Trim(str);
    if strtoint(str) = 1 then
      begin
        ImageON.Visible := True;
        ImageOFF.Visible := False;
      end
    else
      begin
        ImageON.Visible := False;
        ImageOFF.Visible := True;
      end;
  end;
  str := '';

except
  str := '';
end;
end;

procedure TForm1.ClientSocket1Connect(Sender: TObject;
  Socket: TCustomWinSocket);
begin
  Timer3.Enabled := true;
  Label1.Caption := ' ';
  Button3.Enabled := false;
  Button5.Enabled := true;
  ClientSocket1.Socket.SendText('$CMD3' + #13#10);     //    
end;

procedure TForm1.Timer3Timer(Sender: TObject);
begin
    buff := '';
 //-------------------------------------------
    buff := cmd('netsh wlan show interface');
    if pos(':',buff) > 0 then
    begin
      buff := copy(buff,pos(':',buff)+7,Length(buff)-pos(':',buff)+7);
      delete(buff, pos('%',buff), Length(buff));
      Label15.Caption := ' : ' + Trim(buff) + '%';
    end;
 //-------------------------------------------
    buff := cmd('ping.exe -n 1 192.168.4.1');
    if pos('TTL',buff) = 0 then
    begin
      Label1.Caption := ' ';
      ComboBox1.Enabled := true;
      ClientSocket1.Active := false;
      ShowMessage('   WiFi ');
    end;
end;

procedure TForm1.ClientSocket1Error(Sender: TObject;
  Socket: TCustomWinSocket; ErrorEvent: TErrorEvent;
  var ErrorCode: Integer);
begin
  Label1.Caption := ' ';
  ComboBox1.Enabled := true;
  ClientSocket1.Active := false;
end;

procedure TForm1.ComboBox1Change(Sender: TObject);
begin
  if ComboBox1.ItemIndex = 0 then inter := inter1;
  if ComboBox1.ItemIndex = 1 then inter := inter2;
  ComboBox1.hint := inter;
end;

procedure TForm1.ComboBox1DropDown(Sender: TObject);
begin
//-----------------------------------------------------------
  op1 := '';
  op2 := '';
  buff := cmd('netsh wlan show interface');
  temp := buff;
  if pos('  ',buff) = 0 then
  begin
    delete(buff, pos(':',buff), Length(buff));
    inter1 := Trim(copy(buff,pos(':',buff)+4,Length(buff)));
    buff := temp;
    delete(buff, pos(' GUID:',buff), Length(buff));
    op1 := Trim(copy(buff,pos(':',buff)+9,Length(buff)));
    //memo1.Text := inter1 + #13#10 + op1 + #13#10;
  end
  else
  begin
    delete(buff, pos(':',buff), Length(buff));
    inter1 := Trim(copy(buff,pos(':',buff)+4,Length(buff)));
    buff := temp;
    delete(buff, pos(' GUID:',buff), Length(buff));
    op1 := Trim(copy(buff,pos(':',buff)+9,Length(buff)));
    //memo1.Text := inter1 + #13#10 + op1 + #13#10;
    buff := temp;
    delete(buff, 1, pos(' GUID:',buff));
    delete(buff, pos(':',buff), Length(buff));
    inter2 := Trim(copy(buff,pos(':',buff)+4,Length(buff)));
    buff := temp;
    delete(buff, 1, pos(' GUID:',buff));
    delete(buff, pos(' GUID:',buff), Length(buff));
    op2 := Trim(copy(buff,pos(':',buff)+9,Length(buff)));
    //memo1.Text := memo1.Text + inter2 + #13#10 + op2 + #13#10;
  end;

  ComboBox1.Items.Clear;
  if op1 <> '' then ComboBox1.Items.Add(op1);
  if op2 <> '' then ComboBox1.Items.Add(op2);
  ComboBox1.ItemIndex := 0;
//-----------------------------------------------------------

  if ComboBox1.ItemIndex = 0 then inter := inter1;
  if ComboBox1.ItemIndex = 1 then inter := inter2;
  ComboBox1.hint := inter;
end;


end.
